#ifndef UPDATER_H
#define UPDATER_H

#include <QWidget>

#include <QNetworkAccessManager>
#include <QNetworkReply>

#include <QSettings>

#include <QMessageBox>

#include <QProcess>

QT_BEGIN_NAMESPACE
namespace Ui { class Updater; }
QT_END_NAMESPACE

class Updater : public QWidget
{
    Q_OBJECT

private:
    QString modName;
    QString Version;
    QString newVersion;
    QString URL;

    QMessageBox *boxAbout;

    QSettings *settingsMod;

    QNetworkAccessManager *managerSearch;
    QNetworkAccessManager *managerDownload;

    QProcess *procInstall;

public:
    Updater(QWidget *parent = nullptr);
    ~Updater();

    QString getName();

private slots:
    void Search();
    void Download();
    void Install();
    void About();

    void onSearchResult(QNetworkReply *replyS);
    void onDownloadResult(QNetworkReply *replyD);

    void onProgress(qint64 receivedSize, qint64 totalSize);

private:
    Ui::Updater *ui;
};
#endif // UPDATER_H
